function love.load()
    angle = 0
    love.window.setMode(800, 600)
    love.window.setTitle("Aim Hockey")
    love.mouse.setVisible(false)
    math.randomseed(os.time())
    math.random(); math.random(); math.random()
    disk = {}
    sign = {}
    goal = {}
    font = love.graphics.newFont(36)
    font2 = love.graphics.newFont(48)
    font3 = love.graphics.newFont(24)
    start = true
    score = 0
	newGame()
    ttime = 0
    timeout = false
    music = love.audio.newSource("sounds/loop.mp3", stream)
    music:setLooping(true)
    music:play()
    ismusic = true
    isfx = true
    isfullscreen = false
    diskfx = love.audio.newSource("sounds/puck.mp3", static)
    diskfx:setLooping(false)
    donefx = love.audio.newSource("sounds/done.mp3", static)
    donefx:setLooping(false)
    tableimage = love.graphics.newImage("images/table.png")
    diskimage = love.graphics.newImage("images/puck.png")
    obstacleimage = love.graphics.newImage("images/obstacle.png")
    startimage = love.graphics.newImage("images/start.png")
    mimage = love.graphics.newImage("images/m.png")
    fimage = love.graphics.newImage("images/f.png")
    f11image = love.graphics.newImage("images/f11.png")
end

function love.update(dt)
    mx, my = love.mouse.getPosition()
    mousex = (screenwidth / 2) - (400 * scaleratio) + mx
    mousey = my
    if not start and not timeout then
        ttime = ttime + dt
        if math.floor(ttime) == 240 then
            timeout = true
        end
        if not shot then
            disk.velx = (sign.x - disk.x) * 4
            disk.vely = (sign.y - disk.y) * 4
            ratiox = math.abs(disk.velx) / (math.abs(disk.velx) + math.abs(disk.vely))
            ratioy = math.abs(disk.vely) / (math.abs(disk.velx) + math.abs(disk.vely))
        elseif shot then
            time = time + dt
            if disk.velx > 0 then
                decay = friction * time * ratiox
                if decay < disk.velx then
                    disk.velx = disk.velx - decay
                else
                    disk.velx = 0
                end
            end
            if disk.velx < 0 then
                decay = friction * time * ratiox
                if decay < -disk.velx then
                    disk.velx = disk.velx + decay
                else
                    disk.velx = 0
                end
            end
            if disk.vely > 0 then
                decay = friction * time * ratioy
                if decay < disk.vely then
                    disk.vely = disk.vely - decay
                else
                    disk.vely = 0
                end
            end
            if disk.vely < 0 then
                decay = friction * time * ratioy
                if decay < -disk.vely then
                    disk.vely = disk.vely + decay
                else
                    disk.vely = 0
                end
            end
            if disk.velx == 0 and disk.vely == 0 then
                if sign.x ~= disk.x or sign.y ~= disk.y then
                    moves = moves + 1
                end
                shot = false
                time = 0
                if (goal.y - disk.y)^2 + (goal.x - disk.x)^2 < (goal.r + disk.r)^2 then
                    if (goal.y - disk.y)^2 + (goal.x - disk.x)^2 < (goal.r - disk.r)^2 then
                        score = score + (100 - ((moves - 1) * 10))
                        if isfx then
                            donefx:play()
                        end
                        newGame()
                    else
                        score = score + (95 - ((moves - 1) * 10))
                        done = true
                        if isfx then
                            donefx:play()
                        end
                        newGame()
                    end
                end
            end
            disk.x = disk.x + disk.velx * dt
            disk.y = disk.y + disk.vely * dt
            dx = math.abs(disk.x - (obstacle.x + obstacle.w / 2))
            dy = math.abs(disk.y - (obstacle.y + obstacle.h / 2))
            if (dx <= obstacle.w / 2 + disk.r and dy <= obstacle.h / 2 + disk.r) or (dx - obstacle.w / 2)^2 + (dy - obstacle.h / 2)^2 <= disk.r^2 then
                if isfx then
                    diskfx:play()
                end
                if dx >= (disk.r * math.cos(math.rad(45))) + (obstacle.w / 2) then
                    disk.velx = -disk.velx
                end
                if dy >= (disk.r * math.sin(math.rad(45))) + (obstacle.h / 2) then
                    disk.vely = -disk.vely
                end
            end
            if disk.x < 32 then
                if isfx then
                    diskfx:play()
                end
                disk.x = 32
                disk.velx = -disk.velx
            end
            if disk.x > 768 then
                if isfx then
                    diskfx:play()
                end
                disk.x = 768
                disk.velx = -disk.velx
            end
            if disk.y < 32 then
                if isfx then
                    diskfx:play()
                end
                disk.y = 32
                disk.vely = -disk.vely
            end
            if disk.y > 568 then
                if isfx then
                    diskfx:play()
                end
                disk.y = 568
                disk.vely = -disk.vely
            end
        end
    end
end

function love.draw()
    screenheight = love.graphics.getHeight()
    screenwidth = love.graphics.getWidth()
    scaleratio = screenheight / 600
    love.graphics.scale(scaleratio)
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw(tableimage, (screenwidth / 2) - (400 * scaleratio), 0)
    if start then
        love.graphics.setColor(255, 255, 255)
        love.graphics.draw(startimage, (screenwidth / 2) - (400 * scaleratio), 0)
    else
        if not timeout then
        love.graphics.setColor(255, 255, 255)
        love.graphics.draw(obstacleimage, (screenwidth / 2) - (400 * scaleratio) + obstacle.x, obstacle.y)
        love.graphics.setLineWidth(5)
        love.graphics.setColor(255,0,0,150)
        love.graphics.circle("line", ((screenwidth / 2) - (400 * scaleratio)) + goal.x, goal.y, goal.r)
        love.graphics.setColor(255,255,255)
        love.graphics.draw(diskimage, ((screenwidth / 2) - (400 * scaleratio)) + disk.x - 32, disk.y - 32)
        love.graphics.setColor(0, 0, 0, 75)
        love.graphics.setLineWidth(1)
        if not shot then
            love.graphics.line(((screenwidth / 2) - (400 * scaleratio)) + disk.x, disk.y, ((screenwidth / 2) - (400 * scaleratio)) + sign.x, sign.y)
            love.graphics.circle("line", (screenwidth / 2) - (400 * scaleratio) + sign.x, sign.y, sign.r)
        end
        love.graphics.setColor(0, 0, 0)
        love.graphics.setFont(font)
        love.graphics.print(score, (screenwidth / 2) - (400 * scaleratio) + 680, 80)
        love.graphics.setFont(font3)
        if ismusic then
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(mimage, ((screenwidth / 2) - (400 * scaleratio)) + 30, 30)
        else
            love.graphics.setColor(255, 0, 0)
            love.graphics.draw(mimage, ((screenwidth / 2) - (400 * scaleratio)) + 30, 30)
        end          
        if isfx then
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(fimage, ((screenwidth / 2) - (400 * scaleratio)) + 30, 70)
        else
            love.graphics.setColor(255, 0, 0)
            love.graphics.draw(fimage, ((screenwidth / 2) - (400 * scaleratio)) + 30, 70)
        end
        if isfullscreen then
            love.graphics.setColor(255, 255, 255)
            love.graphics.draw(f11image, ((screenwidth / 2) - (400 * scaleratio)) + 30, 110)
        else
            love.graphics.setColor(255, 0, 0)
            love.graphics.draw(f11image, ((screenwidth / 2) - (400 * scaleratio)) + 30 ,110)
        end
        love.graphics.setColor(255, 0, 0)
        love.graphics.setFont(font3)
        love.graphics.print(tostring(240 - math.floor(ttime)), (screenwidth / 2) - (400 * scaleratio) + 680, 40)
        else
            love.graphics.setColor(0, 0, 0)
            msg = love.graphics.newText(font, "Time Is Out!")
            msg2 = love.graphics.newText(font, "Your score is "..score)
            love.graphics.draw(msg, (screenwidth / 2) - (400 * scaleratio) + (400 - msg:getWidth() / 2), 300 - msg:getHeight() / 2)
            love.graphics.draw(msg2, (screenwidth / 2) - (400 * scaleratio) + (400 - msg2:getWidth() / 2), 364)
        end
        love.graphics.setColor(0, 0, 0)
        love.graphics.circle("line", mousex, mousey, 5)
    end
end

function love.keypressed(key)
    if key == "escape" and start then
        love.event.quit()
    end
    if key == "escape" and (not start or timeout) then
        ttime = 0
        start = true
        score = 0
    end
    if key == "space" and not start and not timeout then
        shot = true
    end
    if key == "space" and start then
        timeout = false
        ttime = 0
        start = false
        newGame()
    end
    if key == "m" then
        ismusic = not ismusic
        if ismusic then
            music:play()
        else
            music:stop()
        end
    end
    if key == "f" then
        isfx = not isfx
    end
    if key == "f11" then
        isfullscreen = not isfullscreen
        love.window.setFullscreen(isfullscreen)
        if not isfullscreen then
            love.window.setMode(800, 600)
        end
    end
end

function newGame()
    screenwidth = love.graphics.getWidth()
    screenheight = love.graphics.getHeight()
    scaleratio = screenheight / 600
    side = math.random(2)
    half = math.random(2)
    if half == 1 then
        disk.y = math.random(32, 206)
    else
        disk.y = math.random(394, 568)
    end
    if side == 1 then
        disk.x = math.random(32, 326)
    else
        disk.x = math.random(474, 768)
    end
    disk.r = 32
    disk.velx = 0
    disk.vely = 0
    mx,my = love.mouse.getPosition()
    mousex = (screenwidth / 2) - (400 * scaleratio) + mx
    sign.x = mousex
    sign.y = my
    if (disk.x - mousex)^2 + (disk.y - my)^2 > 200^2 then
        angle = math.atan2((my - disk.y) , (mousex - disk.x))
        sign.x = disk.x + (200 * math.cos(angle))
        sign.y = disk.y + (200 * math.sin(angle))
    end
    sign.velx = 32
    sign.vely = 32
    sign.r = 5
    shot = false
    time = 0
    if half == 1 then
        goal.y = math.random(394, 536)
    else
        goal.y = math.random(64, 206)
    end
    if side == 1 then
        goal.x = math.random(474, 736)
    else
        goal.x = math.random(64, 326)
    end
    goal.r = 64
    moves = 0
    obstacle = {}
    obstacle.x = 380
    obstacle.y = 260
    obstacle.w = 20
    obstacle.h = 60
    friction = 4
    signclicked = false
    signreleased = false
end

function love.mousepressed(mx, my, button)
    if start then
        timeout = false
        ttime = 0
        start = false
        newGame()
    elseif timeout then
        score = 0
        start = true
        timeout = false
    else
        shot = true
    end
end

function love.mousemoved(mx, my)
    sign.x = mx
    sign.y = my
    if (disk.x - mx)^2 + (disk.y - my)^2 > 200^2 then
        angle = math.atan2((my - disk.y) , (mx - disk.x))
        sign.x = disk.x + (200 * math.cos(angle))
        sign.y = disk.y + (200 * math.sin(angle))
    end
end
